{===========================================================================}
{==                                                                       ==}
{==                        SAVE CORECTOR Version 3.3                      ==}
{==                  Copyright (C) 1994-96 By The GodFather               ==}
{==                                                                       ==}
{===========================================================================}

{$M, 16380,65535,655360}

USES
  GUtils, GMemory, GList, GDialogs, GStdDlgs;

CONST
  Version = 'Version 3.31';

TYPE
  GameNames = (
    A7CitiesOfGold,
    ArcticAdventure1,
    ArmorAlley,
    BetraylAtKrondor,
    Caesar,
    Castles1,
    Catacombs3D,
    Centurion,
    CommanderKeen1,
    CommanderKeen2,
    CommanderKeen3,
    CommanderKeen4,
    CommanderKeen5,
    CommanderKeen6,
    Conan,
    CrystalCaves1,
    DarkAges1,
    DeathTrack,
    DungeonsOfDoom,
    Elite2,
    HarleyDavidson,
    HeroesOfM_M1,
    HeroesOfM_M2,
    Hillsfar,
    HistoryLine1418,
    JumpMan,
    KingsBounty,
    Lands,
    Lemmings2,
    LordsOfTheRealm2,
    LuckysCasino,
    MasterOfMagic,
    MasterOfOrion,
    MechWarrior,
    MightAndMagic3,
    MightAndMagic4,
    MightAndMagic5,
    MightAndMagic6,
    MonumentsOfMars,
    MoonBase,
    MotorCity,
    Pirates,
    PrinceOfPersia2,
    Privateer,
    Reunion,
    Scorch,
    SecretAgent1,
    SidAndMaxIncToons,
    SimCity,
    SimEarth,
    SimFarm,
    StreetRod1,
    StreetRod2,
    Supaplex,
    Syndicate,
    TheIncMachine,
    ThunderStrike,
    TransArctica,
    UFO1,
    UFO2,
    UltimaUnderworld,
    Warcraft,
    Whicheaven,
    Zeliard,
    Zeppelin );

CONST
  _I          = ' & ';
  Life        = 'Life';
  Lifes       = 'Lifes';
  Gold        = 'Gold';
  Gems        = 'Gems';
  Time        = 'Time';
  Money       = 'Money';
  Magic       = 'Magic';
  Stocks      = 'Stocks';
  Levels      = 'Levels';
  Energy      = 'Energy';
  Bulets      = 'Bullets';
  Reserves    = 'Reserves';
  Resource    = 'Resources';
  Everything  = 'Everything';


TYPE
  TExtension= STRING[3];
  PGameInfo = ^TGameInfo;
  TGameInfo = OBJECT( TObject )
         ID : GameNames; { Game ID }
       Name : PString;   { Game name }
       Func : PString;   { Corect function }
       FMasc: PString;   { File masc (name) }
       CONSTRUCTOR Init(aID: GameNames;
                        aName: STRING;
                        aFunc: STRING;
                        aFMasc: STRING );
       DESTRUCTOR Done; VIRTUAL;
  END;

  PDataCollection = ^TDataCollection;
  TDataCollection = OBJECT(TSortedCollection)
    FUNCTION KeyOf(Item:Pointer): Pointer;        VIRTUAL;
    FUNCTION Compare(Key1,Key2:Pointer): Integer; VIRTUAL;
  END;

  PGamesList = ^TGamesList;
  TGamesList = OBJECT(TList)
     FUNCTION  __GetLine     (ListPos: Integer): STRING;               VIRTUAL;
     PROCEDURE __HookListKeys(ListPos: Integer; VAR PressedKey: Word); VIRTUAL;
     PROCEDURE __IdleListCall(ListPos: Integer);                       VIRTUAL;
  END;


{ Global variables }
VAR
  Database   : PDataCollection;
  CurrentGAME: PGameInfo;
  SaveNum    : Integer;              { SAVEGAME Number for special purposes }
  GamesList  : PGamesList;

{============================================================================}
FUNCTION TDataCollection.KeyOf(Item: Pointer): Pointer;
BEGIN
  KeyOf := @PGameInfo(Item)^.Name;
END;

FUNCTION TDataCollection.Compare(Key1, Key2: Pointer): Integer;
BEGIN
  IF PString(Key1^)^ = PString(Key2^)^
    THEN Compare := 0
    ELSE IF PString(Key1^)^ < PString(Key2^)^
      THEN Compare := -1
      ELSE Compare := 1;
END;

CONSTRUCTOR TGameInfo.Init(aID: GameNames;
                           aName: STRING;
                           aFunc: STRING;
                           aFMasc: STRING );
BEGIN
  ID    := aID;
  Name  := NewStr(aName);
  FMasc := NewStr(aFMasc);
  IF aFunc <> ''
    THEN Func := NewStr(aFunc)
    ELSE Func := NIL;
END;

DESTRUCTOR TGameInfo.Done;
BEGIN
  DisposeStr(Name);
  DisposeStr(FMasc);
  IF Func <> NIL
    THEN DisposeStr(Func);
END;
{============================================================================}


FUNCTION GetSaveNum: Boolean;
VAR Result:Integer; D:PDialog; Num:STRING[3]; Min,Max:Byte;
BEGIN
  Min := 1;
  Max := 99;
  Num := '1';
  CASE CurrentGame^.ID OF
    PrinceOfPersia2 : Max := 10;
    Pirates         : Max := 4;
    Lemmings2       : Max := 8;
  END;
  New(D, Init(13,MaxY DIV 2-4,52,10,DefaultDialogPAL,Single1,'Information'));
  WITH D^ DO
  BEGIN
    AddStaticText(9,3,$57,$5E,'Enter the number of SAVEGAME (~'+IntToStr(Min)+'..'+IntToStr(Max)+'~)');
    AddNumInputLine(0,0,'',0,23,5,Min,Max,Num);
    AddButtons;
     AddButton('    ~O~K    ',kbAltO,12,8,btDefault);
     AddButton('  ~C~ancel  ',kbAltC,30,8,btCancel);
    Result := Process(2);
  END;
  Dispose(D, Done);
  IF Result = 1 THEN GetSaveNum := True ELSE GetSaveNum := False;
  SaveNum := StrToInt(Num);
END;


PROCEDURE WriteLOGO1;
VAR X,Y: Byte;
BEGIN
  FOR X := 1 TO 80 DO IF Odd(X) THEN ClearAttr(X,1,X,8,$02) ELSE ClearAttr(X,1,X,8,$0A);
  FOR Y := 1 TO 12 DO IF Odd(Y) THEN ClearAttr(5,Y,80,Y,$02);
  X := 5; Y := 1;
  PlainWrite(X,Y+00,' ¿   ¿   ڿ   ڿ   ¿');
  PlainWrite(X,Y+01,'ſ ſ Ŵ   ſ ſ');
  PlainWrite(X,Y+02,'Ŵ  Ŵ  Ŵ Ŵ   Ŵ Ŵ     ķ');
  PlainWrite(X,Y+03,'¿  Ŵ Ŵ   Ŵ ¿      ĿĿĿĿĿĿĿ');
  PlainWrite(X,Y+04,' ſ Ŵ Ŵ   Ŵ                    ');
  PlainWrite(X,Y+05,'¿ Ŵ Ŵ  Ŵ ſ  Ŵ  ¿          ');
  PlainWrite(X,Y+06,' Ŵ         Ľ');
  PlainWrite(X,Y+07,'              ');
  WriteBetween(1,80,Y+9 ,$07,'Copyright (C) 1994-97 By The GodFather');
  WriteBetween(1,80,Y+10,$07,Version);
END;

PROCEDURE WriteLOGO2;
BEGIN
  FastWrite(14, 6,$D,'ķ ķ ''ķ    ');
  FastWrite(14, 7,$D,'                 ');
  FastWrite(14, 8,$D,' ķ    ķ       ');
  FastWrite(14, 9,$D,'              ');
  FastWrite(14,10,$D,'Ľ      Ľ        ');
  FastWrite(14,11,$D,'                    ');
  FastWrite(14,12,$D,'              ');
  FastWrite(14,13,$D,'      ');
  FastWrite(14,14,$D,'         ');
  FastWrite(14,15,$D,'   ');
  FastWrite(14,16,$D,'                  ');
  FastWrite(14,17,$D,'        ');
  FastWrite(14,18,$D,'               ');
  FastWrite(14,19,$D,'      ');
  FastWrite(14,20,$D,'   ');
  ClearAttr(14,5,30,10,$0E);
END;

PROCEDURE About;
VAR OK: PButtons; UpY: Byte;
BEGIN
  UpY := MaxY DIV 2-5;
  OpenWin(10,UpY,60,12,$5D,$5F,Single1,'About');
  WriteBetween(10,70,UpY+2,$5E,' SAVE CORECTOR '+Version+' ');
  WriteBetween(10,70,UpY+3,$5E,' Copyright (C) 1994-96 By The GodFather ');
  WriteBetween(10,70,UpY+5,$5A,'         the_godfader@hotmail.com       ');
  WriteBetween(10,70,UpY+6,$5A,'         http://pzcrackteam.home.ml.org/');
  WriteBetween(10,70,UpY+7,$5A,'         http://fly.to/pct/             ');
  FastWrite   (20,UpY+5,$57,' E-Mail:');
  FastWrite   (20,UpY+6,$57,' H-Page:');
  InitPallette(DefaultDialogPAL);
  OK := New(PButtons, Init);
  OK^.AddBtn('    ~O~K    ',kbAltO,36,UpY+10,btDefault);
  OK^.Process;
  Dispose(OK, Done);
  RmWin;
END;
{============================================================================}

{$I-}
PROCEDURE InitCollection;

  PROCEDURE g(ID:GameNames; Name,Func,FMasc:STRING);
    BEGIN Database^.Insert(New(PGameInfo, Init(ID,Name,Func,FMasc))); END;

BEGIN
  Database := New(PDataCollection, Init(1,1));

  g( A7CitiesOfGold   ,'7 Cities Of Gold'         ,Money          ,'GAME????.SAV');
  g( ArcticAdventure1 ,'Arctic Adventure 1'       ,Bulets         ,'AA1.SAV'     );
  g( ArmorAlley       ,'Armor Alley'              ,Money          ,'*.SAV'       );
  g( BetraylAtKrondor ,'Betrayal At Krondor'      ,Everything     ,'SAVE????.GAM'); { GAMES\SAVES.G01\ }
  g( Caesar           ,'Caesar'                   ,Money          ,'*.SAV'       );
  g( Castles1         ,'Castles 1'                ,Money          ,'SAVEGAME.0??');
  g( Catacombs3D      ,'Catacombs 3D'             ,Everything     ,'SAVEGAM?.C3D');
  g( Centurion        ,'Centurion'                ,Money          ,'*.CSV'       );
  g( CommanderKeen1   ,'Commander Keen 1'         ,Lifes+_I+Bulets,'SAVED???.CK1');
  g( CommanderKeen2   ,'Commander Keen 2'         ,Lifes+_I+Bulets,'SAVED???.CK2');
  g( CommanderKeen3   ,'Commander Keen 3'         ,Lifes+_I+Bulets,'SAVED???.CK3');
  g( CommanderKeen4   ,'Commander Keen 4'         ,Lifes+_I+Bulets,'SAVEGAM?.CK4');
  g( CommanderKeen5   ,'Commander Keen 5'         ,Lifes+_I+Bulets,'SAVEGAM?.CK5');
  g( CommanderKeen6   ,'Commander Keen 6'         ,Lifes+_I+Bulets,'SAVEGAM?.CK6');
  g( Conan            ,'Conan The Cimmerian'      ,Everything     ,'SAVE.DAT'    );
  g( CrystalCaves1    ,'Crystal Caves 1'          ,Bulets         ,'CC1-????.SAV');
  g( DarkAges1        ,'Dark Ages 1'              ,Everything     ,'SAVEGAME.DA1');
  g( DeathTrack       ,'Death Track'              ,Money          ,'*.RCT'       );
  g( DungeonsOfDoom   ,'Dungeons Of Doom'         ,Life+_I+Magic  ,'DOD.SV?'     );
  g( Elite2           ,'Elite-2'                  ,Stocks         ,'*.CDR'       );
  g( HarleyDavidson   ,'Harley Davidson'          ,Money          ,'GAMESAVE.HD' );
  g( HeroesOfM_M1     ,'Heroes of Might and Magic (Standart)',Everything,'*.GM1' ); {GAME\}
  g( HeroesOfM_M2     ,'Heroes of Might and Magic (Campaign)',Everything,'*.CGM' ); {GAME\}
  g( Hillsfar         ,'Hillsfar'                 ,Money          ,'*.HIL'       );
  g( HistoryLine1418  ,'History Line 1914-1918'   ,Resource       ,'0???????.DAT');
  g( JumpMan          ,'Jumpman Lives'            ,Lifes          ,'JMLIVES!.SAV');
  g( KingsBounty      ,'King''s Bounty'           ,Everything     ,'*.DAT'       );
  g( Lands            ,'Lands Of Lore'            ,Everything     ,'_SAVE???.DAT');
  g( Lemmings2        ,'Lemmings 2'               ,Levels         ,'SAVE.DAT'    );
  g( LordsOfTheRealm2 ,'Lords Of The Realm 2'     ,Money          ,'*.SAV'       );
  g( LuckysCasino     ,'Lucky''s Casino Adventure',Money          ,'PLYR????.INF');
  g( MasterOfMagic    ,'Master Of Magic'          ,Money+_I+'Mana','SAVE????.GAM');
  g( MasterOfOrion    ,'Master Of Orion'          ,Reserves       ,'SAVE????.GAM');
  g( MechWarrior      ,'Mech Warrior'             ,Money          ,'*.GAM'       );
  g( MightAndMagic3   ,'Might And Magic 3'        ,Gold+_I+Gems   ,'SAVE????.MM3');
  g( MightAndMagic4   ,'Might And Magic 4'        ,Gold+_I+Gems   ,'XEEN????.SAV');
  g( MightAndMagic5   ,'Might And Magic 5'        ,Gold+_I+Gems   ,'DARK????.SAV');
  g( MightAndMagic6   ,'Might And Magic 6'        ,Gold+_I+Gems   ,'SWRD????.SAV');
  g( MonumentsOfMars  ,'Monuments Of Mars 1'      ,Bulets         ,'MARS1.SV1'   );
  g( MoonBase         ,'Moonbase'                 ,Money          ,'*.MBS'       );
  g( MotorCity        ,'Motor City'               ,Money          ,'GAME*.GAM'   );
  g( Pirates          ,'Pirates'                  ,Everything     ,'DISKS'       );
  g( PrinceOfPersia2  ,'Prince Of Persia 2'       ,Life+_I+Time   ,'PRINCE.SAV'  );
  g( Privateer        ,'Privateer'                ,Money          ,'*.SAV'       );
  g( Reunion          ,'Reunion'                  ,Money          ,'SPIDYSAV.*'  ); { SAVE\ }
  g( Scorch           ,'Scorch'                   ,Money          ,'*.'          );
  g( SecretAgent1     ,'Secret Agent 1'           ,Bulets         ,'SAM1-???.SAV');
  g( SidAndMaxIncToons,'Sid And Max Incr. Toons'  ,Levels         ,'TOONS.SAV'   );
  g( SimCity          ,'Sim City'                 ,Money          ,'*.CTY'       );
  g( SimEarth         ,'Sim Earth'                ,Energy         ,'*.PLA'       );
  g( SimFarm          ,'Sim Farm'                 ,Money          ,'*.SFM'       );
  g( StreetRod1       ,'Street Rod 1'             ,Money          ,'HOTROD??.SAV');
  g( StreetRod2       ,'Street Rod 2'             ,Money          ,'HOTROD??.SAV');
  g( Supaplex         ,'Supaplex'                 ,Levels         ,'PLAYER.LST'  );
  g( Syndicate        ,'Syndicate'                ,Money          ,'*.GAM'       ); { SAVE\ }
  g( TheIncMachine    ,'The Incredible Machine 1' ,Levels         ,'TIM.CFG'     );
  g( ThunderStrike    ,'Thunder Strike'           ,Money          ,'PLR0'        );
  g( TransArctica     ,'TransArctica'             ,Money          ,'*.SAV'       );
  g( UFO1             ,'UFO 1 "Enemy unknown"'    ,Money          ,'LIGLOB.DAT'  ); { GAME_??\ }
  g( UFO2             ,'UFO 2 "Terror from the deep"',Money       ,'LIGLOB.DAT'  ); { GAME_??\ }
  g( UltimaUnderworld ,'Ultima Underworld'        ,Everything     ,'PLAYER.DAT'  ); { SAVE?\ }
  g( Warcraft         ,'Warcraft'                 ,'Gold & Lumber','SAVE????.SAV');
  g( Whicheaven       ,'Whicheaven'               ,Everything     ,'SVGN????.DAT');
  g( Zeliard          ,'Zeliard'                  ,Money          ,'*.USR'       );
  g( Zeppelin         ,'Zeppelin'                 ,Everything     ,'SPIEL?.SAV'  );
END;

PROCEDURE CorectSAVEGAME(FileName: STRING);
VAR   SaveFile : FILE OF Byte;
      A,B,C,D  : Byte;
      I,R      : Integer;
      Offset   : Longint;

  FUNCTION GetPrivOffset : LongInt;
  VAR PrivFile: FILE;
      PrivBuf : ARRAY[1..4096] OF byte;
      Z,X,C,V : Integer;
      I,R     : Integer;
  BEGIN
    {$I-}
    Assign(PrivFile, FileName);
    Reset(PrivFile, 1);
    BlockRead(PrivFile, PrivBuf, SizeOf(PrivBuf), I);
    Z := 0; X := 1;
    C := 2; V := 3;
    FOR R := 1 TO I DO
    BEGIN
      Inc(Z); Inc(X);
      Inc(C); Inc(V);
      IF (PrivBuf[z] = $44) AND
         (PrivBuf[x] = $41) AND
         (PrivBuf[c] = $54) AND
         (PrivBuf[v] = $41)
         THEN BEGIN
                GetPrivOffset := R - 9;
                Close(PrivFile);
                Exit;
              END;
    END;
    GetPrivOffset := -1;
    Close(PrivFile);
    {$I+}
  END { GetPrivOffset };

  PROCEDURE WriteOneMiliard(Offset: LongInt);
  BEGIN
    IF Offset = -1 THEN Exit;
    A := $00; B := $CA; C := $9A; D := $3B;
    {$I-}
      Seek (SaveFile, Offset);
      Write(SaveFile, A,B,C,D);
    {$I+}
  END;

  PROCEDURE WriteTwoMiliards(Offset: LongInt);
  BEGIN
    IF Offset = -1 THEN Exit;
    A := $00; B := $94; C := $35; D := $77;
    {$I-}
      Seek (SaveFile, Offset);
      Write(SaveFile, A,B,C,D);
    {$I+}
  END;

BEGIN
 Assign(SaveFile,FileName);
 {$I-}
   Reset(SaveFile);
 {$I+}
 IF IOResult <> 0 THEN
 BEGIN
   InfoBox('Error opening '+FileName,True);
   Exit;
 END;
 A := $00; B := $CA; C := $9A; D := $3B;
 {$I-}
 CASE CurrentGAME^.ID OF
 A7CitiesOfGold:   BEGIN
                     A := $49;
                     Seek(SaveFile,   37368); Write(SaveFile, A);
                   END;
 ArcticAdventure1: BEGIN
                     A := $20; B := $4E;
                     Seek(SaveFile,      10); Write(SaveFile, A,B);
                   END;
 ArmorAlley:       BEGIN
                     A := $00; B := $7D;
                     Seek(SaveFile,   16762); Write(SaveFile, A,B);
                   END;
 BetraylAtKrondor: BEGIN
                     Seek(SaveFile,     102); Write(SaveFile, A,B,C,D);
                     A := $64; B := $00;
                     Seek(SaveFile,     227); FOR I := 1 TO 7 DO Write(SaveFile, A,A,A, B,B);
                                              Write(SaveFile, B,B,B,B,B);
                                              FOR I := 1 TO 8 DO Write(SaveFile, A,A,A, B,B);

                     Seek(SaveFile,     322); FOR I := 1 TO 7 DO Write(SaveFile, A,A,A, B,B);
                                              Write(SaveFile, B,B,B,B,B);
                                              FOR I := 1 TO 8 DO Write(SaveFile, A,A,A, B,B);

                     Seek(SaveFile,     417); FOR I := 1 TO 5 DO Write(SaveFile, A,A,A, B,B);
                     Seek(SaveFile,     447); FOR I := 1 TO 10 DO Write(SaveFile, A,A,A, B,B);

                     Seek(SaveFile,     512); FOR I := 1 TO 16 DO Write(SaveFile, A,A, B,B,B);
                     Seek(SaveFile,     623); FOR I := 1 TO 16 DO Write(SaveFile, A,A, B,B,B);
                     Seek(SaveFile,     707); FOR I := 1 TO 16 DO Write(SaveFile, A,A, B,B,B);
                   END;
 Caesar:           BEGIN
                     A := $00; B := $7D;
                     Seek(SaveFile,      62); Write(SaveFile, A,B);
                   END;
 Castles1:         BEGIN
                     A := $30; B := $75;
                     Seek(SaveFile,      59); Write(SaveFile, A,B);
                     Seek(SaveFile,     167); Write(SaveFile, A,B);
                   END;
 Catacombs3D:      BEGIN
                     A := $20; B := $4E;
                     Seek(SaveFile,     46); Write(SaveFile, A,B, A,B, A,B);
                   END;
 Centurion:        BEGIN
                     A := $00; B := $7D;
                     Seek(SaveFile,   1530); Write(SaveFile, A, B);
                   END;
 Conan:            BEGIN
                     A := $FF; B := $64; C := $50; D := $C3;
                     Seek(SaveFile,     22); Write(SaveFile, C,D);
                                             FOR I := 1 TO 7 DO Write(SaveFile, A);
                     Seek(SaveFile,     37); Write(SaveFile, B,B,B);
                   END;
 CommanderKeen1,
 CommanderKeen2,
 CommanderKeen3:   BEGIN
                     A := $64; B := $20; C := $4E;
                     Seek(SaveFile,     50); Write(SaveFile, A);
                     Seek(SaveFile,     52); Write(SaveFile, B,C);
                   END;
 CommanderKeen4,
 CommanderKeen5,
 CommanderKeen6:  BEGIN
                    A := $64; B := $20; C := $4E;
                    Offset := 120;
                    CASE CurrentGAME^.ID OF
                      CommanderKeen4: Inc(Offset,2);
                      CommanderKeen5: Inc(Offset,4);
                      CommanderKeen6: Inc(Offset,6);
                    END;
                    Seek(SaveFile,  Offset); Write(SaveFile, A);
                    Seek(SaveFile,     104); Write(SaveFile, B,C);
                  END;
 CrystalCaves1:   BEGIN
                    A := $20; B := $4E;
                    Seek(SaveFile,       4); Write(SaveFile, A,B);
                  END;
 DarkAges1:       BEGIN
                    A := $C8;
                    Seek(SaveFile,       5); Write(SaveFile, A);
                  END;
 DeathTrack:      BEGIN
                    A := $00; B := $7D; C := $02;
                    Seek(SaveFile,       4); FOR I := 1 TO 9 DO Write(SaveFile, A,B);
                    Seek(SaveFile,     376); FOR I := 1 TO 14 DO
                                             BEGIN
                                               Write(SaveFile, C);
                                               Read(SaveFile, D);
                                             END;
                  END;
 DungeonsOfDoom:  BEGIN
                    A := $10; B := $27;
                    Seek(SaveFile,       4); Write(SaveFile, A,B, A,B);
                    Seek(SaveFile,      22); Write(SaveFile, A,B, A,B);
                    Seek(SaveFile,      40); Write(SaveFile, A,B, A,B);
                  END;
 Elite2:          BEGIN
                    A := $FA;
                    Seek(SaveFile,     160); FOR I := 1 TO 32 DO Write(SaveFile, A);
                  END;
 Hillsfar:        BEGIN
                    A := $00; B := $7D;
                    Seek(SaveFile,      32); Write(SaveFile, A,A);
                    Seek(SaveFile,      40); Write(SaveFile, A,B, A,B);
                    Seek(SaveFile,      46); Write(SaveFile, A,B, A,B);
                  END;
 HarleyDavidson:  BEGIN
                    A := $10; B := $27;
                    Seek(SaveFile,      30); Write(SaveFile, A,B);
                  END;
 HeroesOfM_M1,
 HeroesOfM_M2:    BEGIN
                     A := $00; B := $7D;
                     C := $00; D := $00;
                     Seek(SaveFile,    367); FOR I := 1 TO 7 DO Write(SaveFile,A,B,C,D);
                  END;
 HistoryLine1418: BEGIN
                    A := $00; B := $7D;
                    Seek(SaveFile,   35409); Write(SaveFile, A,B);
                  END;
 JumpMan:         BEGIN
                    A := $14;
                    Seek(SaveFile,      55); Write(SaveFile, A);
                  END;
 KingsBounty:     BEGIN
                    A := $00; B := $7D;
                    Seek(SaveFile,    3747); Write(SaveFile, A,B, A,B);
                    Seek(SaveFile,    4027); Write(SaveFile, A,B);
                    Seek(SaveFile,    4033); Write(SaveFile, A,B, A,B);
                  END;
 Lands:           BEGIN
                    A := $00; B := $7D;
                    Seek(SaveFile,     120); Write(SaveFile, A,B, A,B, A,B, A,B, A,B);
                    Seek(SaveFile,     250); Write(SaveFile, A,B, A,B, A,B, A,B, A,B);
                    Seek(SaveFile,     380); Write(SaveFile, A,B, A,B, A,B, A,B, A,B);
                    Seek(SaveFile,    1113); Write(SaveFile,A,B);
                  END;
 Lemmings2:       BEGIN
 { ????? }          A := $00;  B := $03; C := $3C;
                    IF SaveNum > 1
                      THEN Offset := 480 * (SaveNum - 1) + 201
                      ELSE Offset := 200;
                    Seek(SaveFile,  Offset);
                    FOR R := 1 TO 14 DO
                      FOR I := 1 TO 10 DO
                      BEGIN
                        Write(SaveFile, C);
                        Dec(C,2);
                        Write(SaveFile, A,B,A);
                      END;
                  END;
LordsOfTheRealm2: WriteTwoMiliards( (165*512) + 328 );
 LuckysCasino:    WriteOneMiliard(52);
 MonumentsOfMars: BEGIN
                    Read(SaveFile, A);
                    A := $96;
                    Write(SaveFile, A);
                  END;
 MightAndMagic3,
 MightAndMagic4,
 MightAndMagic5,
 MightAndMagic6: BEGIN
                    CASE CurrentGAME^.ID OF
                      MightAndMagic3: Offset := 11909;
                      MightAndMagic4: Offset := 13699;
                      MightAndMagic5: Offset := 14843;
                      MightAndMagic6: Offset := 13691;
                    END;
                    Seek(SaveFile,  Offset); FOR I := 1 TO 4 DO Write(SaveFile, A,B,C,D);
                  END;
 MoonBase:        WriteOneMiliard(41018);
 MechWarrior:     WriteOneMiliard(73);
 MasterOfMagic:   BEGIN
                    A := $00; B := $7D;
                    Seek(SaveFile,    3140); Write(SaveFile, A,B);
                    Seek(SaveFile,    3390); Write(SaveFile, A,B);
                  END;
 MasterOfOrion:   BEGIN
                    A := $00; B := $E1;
                    C := $F5; D := $05;
                    Seek(SaveFile,   29716); Write(SaveFile, A,B,C,D);
                  END;
 MotorCity:       BEGIN
                    A := $00; B := $84;
                    C := $35; D := $77;
                    Seek(SaveFile,     408); Write(SaveFile, A,B,C,D);
                  END;
 Pirates:         BEGIN
 { ????? }          A := $30; B := $03; C := $64;
                    CASE SaveNum of
                      1: Seek(SaveFile,5907);
                      2: Seek(SaveFile,10003);
                      3: Seek(SaveFile,14099);
                      4: Seek(SaveFile,18195);
                    END;
                    Write(SaveFile, A,B,C);
                    A := $FF; B := $00; C := $BB;
                    Seek(SaveFile, FilePos(SaveFile) + 3); Write(SaveFile, A,A,A);
                    Seek(SaveFile, FilePos(SaveFile) + 1); Write(SaveFile, B,C);
                  END;
 PrinceOfPersia2: BEGIN
 { ????? }          A := $B4; B := $29;
                    Offset := (9623 * SaveNum) + 256;
                    Seek(SaveFile,  Offset); Write(SaveFile, A);
                    Seek(SaveFile,Offset+5); Write(SaveFile, B);
                  END;
 Privateer:       WriteOneMiliard(GetPrivOffset);
 Reunion:         WriteOneMiliard(14476);
 SecretAgent1:    BEGIN
                    A := $20; B := $4E;
                    Seek(SaveFile,      10); Write(SaveFile, A,B);
                  END;
 Scorch:          WriteOneMiliard(54);
 SidAndMaxIncToons: BEGIN
                    A := $01;
                    Seek(SaveFile,      88); FOR I := 1 TO 99 DO Write(SaveFile, A);
                  END;
 SimCity:         BEGIN
                    Seek(SaveFile,    3108); Write(SaveFile, D,C,B,A);
                  END;
 SimEarth:        BEGIN
                    A := $FF;
                    Seek(SaveFile,   39828); Write(SaveFile, A,A);
                  END;
 SimFarm:         WriteOneMiliard(136932);
 StreetRod1,
 StreetRod2:      BEGIN
                    A := $00; B := $7D;
                    Offset := 16;
                    IF CurrentGAME^.ID = StreetRod2 THEN Offset := 36;
                    Seek(SaveFile,  Offset); Write(SaveFile, A,B);
                  END;
 Supaplex:        BEGIN
                    A := $01;
                    Seek(SaveFile, 12);
                    FOR I := 1 TO 115 DO Write(SaveFile, A);
                  END;
 Syndicate:       WriteOneMiliard(20);
 TheIncMachine:   BEGIN
                    A := $D5;
                    Write(SaveFile, A);
                  END;
 ThunderStrike:   WriteOneMiliard(229);
 TransArctica:    BEGIN
                    A := $7D; B := $00;
                    Seek(SaveFile,      18); Write(SaveFile, A,B, A,B);
                  END;
 UFO1,UFO2:       WriteOneMiliard(0);
 UltimaUnderworld:BEGIN
                    A := $FE;
                    B := $FF;
                    Seek(SaveFile,      32); Write(SaveFile, A,A);
                                             FOR I := 1 TO 30 DO Write(SaveFile, B);
                    Seek(SaveFile,      77); Write(SaveFile, B,B,B);
                  END;
 Warcraft:        BEGIN
                    WriteOneMiliard(1542);
                    WriteOneMiliard(1562);
                  END;
 Whicheaven:      BEGIN
                    A := $C8;
                    FOR I := 0 TO 45 DO Seek(SaveFile,65+(I*4)); Write(SaveFile,A);
                    WriteOneMiliard(341);
                    WriteOneMiliard(345);
                  END;
 Zeliard:         BEGIN
                    A := $7A; B := $00; C := $12;
                    Seek(SaveFile,     136); Write(SaveFile, A,B,C);
                  END;
 Zeppelin:        BEGIN
                    A := $00; B := $CA; C := $9A; D := $3B;
                    Seek(SaveFile,    1055);
                    FOR I := 1 TO 13 DO Write(SaveFile,A,B,C,D);
                    A := $E7; B := $03;
                    Seek(SaveFile,    1117); Write(SaveFile, A,B);
                    A := $63;
                    Seek(SaveFile,    1113); Write(SaveFile, A);
                    Seek(SaveFile,    1137); Write(SaveFile, A);
                  END;
 END; {CASE}
 Close(SaveFile);
 {$I+}
 InfoBox('SAVEGAME is corected',False);
END { CorectSave };
{$I+}


{ -------------------------------------------------------------------------- }
{ ----------------------------- TGamesList ROUTINES ------------------------ }
{ -------------------------------------------------------------------------- }
FUNCTION TGamesList.__GetLine(ListPos: Integer): STRING;
BEGIN
  CurrentGame := Database^.At(ListPos-1);
  __GetLine   := ' '+CurrentGame^.Name^;
END;

PROCEDURE TGamesList.__IdleListCall(ListPos: Integer);
BEGIN
  CurrentGAME := Database^.At(ListPos-1);
  FastWrite(29,MaxY-1,$1A,PadLeft(CurrentGame^.Func^ ,20,' '));
  FastWrite(56,MaxY-1,$1A,PadLeft(CurrentGame^.FMasc^,12,' '));
END;

PROCEDURE TGamesList.__HookListKeys(ListPos: Integer; VAR PressedKey:Word);
VAR FName:STRING;
BEGIN
  CASE PressedKey OF
       kbF1: About;
    kbEnter: BEGIN
               IF FileDialog('Choose SAVEGAME',CurrentGame^.FMasc^,FName)
                 THEN BEGIN
                        CASE CurrentGame^.ID OF
                          PrinceOfPersia2,
                          Pirates,
                          Lemmings2: IF NOT GetSaveNum THEN Exit;
                        END;
                        CorectSAVEGAME(FName);
                      END;
             END;
  END;
END;
{ -------------------------------------------------------------------------- }
{ -------------------------------------------------------------------------- }



PROCEDURE Initialize;
BEGIN
  XDlgPos := 13;

  Cursor(Off);
  SetBlink(False);
  MaxKeyboardSpeed;

  ClrScr(7);
  SetPAL(AltPAL);
  WriteLOGO1;

  InitCollection;

  FBox(9,13,69,MaxY,$19,Special2);
  WriteBetween(9,69,13,$19,'['+Replicate(13,' ')+']');
  WriteBetween(9,69,13,$1E,'Choose game');

  SmartHLine(9,69,MaxY-2,$19,SingleLine);
  FastWrite(11,MaxY-1,$1B,'WHAT IS CORECTED:');
  FastWrite(50,MaxY-1,$1B,'FILE:');
  WriteHi(11,MaxY  ,$17,$1E,' Total games: ~'+AddComas(Database^.Count)+'~ ');

  GamesList := New(PGamesList,
                         Init(10,              { ListX       : Byte;    }
                              14,              { ListY       : Byte;    }
                              59,              { BarSize     : Byte;    }
                              MaxY-16,         { Lines       : Byte;    }
                              Database^.Count, { MaxTopics   : Integer; }
                              False,           { SelectionON : Boolean; }
                              True,            { FastFindON  : Boolean; }
                              13,              { FastFindX   : Byte;    }
                              MaxY-2,          { FastFindY   : Byte;    }
                              '',             { FastFindCHR : Char;    }
                              True,            { ScrollerON  : Boolean; }
                              69,              { ScrollerX   : Byte;    }
                              14,              { ScrollerY1  : Byte;    }
                              MaxY-3,          { ScrollerY2  : Byte;    }
                              lDefaultPal));   { Pallette    : Pals;    }
  GamesList^.Process;
END;

BEGIN
  Initialize;
  Dispose(Database,Done);
  ClrScr(7);
  SetPAL(OrgPAL);
  WriteLOGO2;
  SetBlink(True);
  PosCursor(1,24);
  Cursor(On);
END.
